Error handling in Bash
This article introduces error handling in bash. Remember, understanding exit codes, options such as errexit and trap allow us to build robust scripts and manage bash problems more effectively.
Exit Codes in Bash
Handling errors based on exit codes is a standard technique for detecting command failures. This is especially true for external commands.
The curl command in bash is a good example of handling problems based on known error codes. In contrast to user-defined routines, external command error codes are fully documented.
${?}
Stores the exit status of the last command executed before the given line. Code 0 means the command was executed successfully. Otherwise, something went wrong.
case {?} in
0) {
true # ok
} ;;
*) {
false # something went wrong
}
Bash error handling can be performed using simple exit codes. You can try until you find a lazier solution. At least, anyone would do so after performing some conditional handling of the problem based on the error code.
Error exit
Exiting on error is undoubtedly the most useful error detection and handling capability that bash programmers lack in the first place.
Trap, Exit, and Error
trap allows us to specify a command to be executed when the shell receives a signal. SIGNAL SPEC is the name of the signal. Some common signals are EXIT
, ERROR
, , DEBUG
and RETURN
.
We can use the trap -l command to list more signals. We can also use trap -p SIGSPEC to determine which commands are associated with a certain signal.
For example, we might want to determine which commands correspond to the ERR signal. In that case, we could type the following command line:
trap -p ERR
If the output is empty, trap has not yet associated any command with the signal.
_() { echo oops ; }
trap _ ERR EXIT
Print signal commands now do not produce empty results.
enter:
trap -p EXIT ERR
Output:
trap -- '_' EXIT
trap -- '_' ERR
For reprinting, please send an email to 1244347461@qq.com for approval. After obtaining the author's consent, kindly include the source as a link.
Related Articles
How to decompress x.tar.xz format files under Linux
Publish Date:2025/04/08 Views:186 Category:OPERATING SYSTEM
-
A lot of software found today is in the tar.xz format, which is a lossless data compression file format that uses the LZMA compression algorithm. Like gzip and bzip2, it supports multiple file compression, but the convention is not to compr
Summary of vim common commands
Publish Date:2025/04/08 Views:115 Category:OPERATING SYSTEM
-
In Linux, the best editor should be vim. However, the complex commands behind vim's powerful functions also make us daunted. Of course, these commands do not need to be memorized by rote. As long as you practice using vim more, you can reme
Detailed explanation of command return value $? in Linux
Publish Date:2025/04/08 Views:58 Category:OPERATING SYSTEM
-
? is a special variable. This variable represents the return value of the previous command. That is to say, when we run certain commands, these commands will return a code after running. Generally, if the command is successfully run, the re
Common judgment formulas for Linux script shell
Publish Date:2025/04/08 Views:159 Category:OPERATING SYSTEM
-
In shell script programming, predicates are often used. There are two ways to use predicates, one is to use test, and the other is to use []. Let's take a look at how to use these two methods through two simple examples. Example 1 # test –
Shell script programming practice - specify a directory to delete files
Publish Date:2025/04/08 Views:98 Category:OPERATING SYSTEM
-
Usually, in Linux system we need to frequently delete some temporary files or junk files. If we delete them one by one manually, it will be quite troublesome. I have also been learning shell script programming recently, so I tried to write
Use of Linux command at - set time to execute command only once
Publish Date:2025/04/08 Views:158 Category:OPERATING SYSTEM
-
This article mainly involves a knowledge point, which is the atd service. Similar to this service is the crond service. The functions of these two services can be similar to the two functional functions of javascript. Those who have learned
Use of Linux command crontab - loop execution of set commands
Publish Date:2025/04/08 Views:170 Category:OPERATING SYSTEM
-
Compared with at , which executes a command only once, crontab, which we are going to talk about in this article, executes the set commands in a loop. Similarly, the use of crontab requires the support of the crond service. The service is s
Linux practice - regularly delete files under the directory
Publish Date:2025/04/08 Views:198 Category:OPERATING SYSTEM
-
Since we want to delete the files under the directory regularly, we need to use the Linux crontab command. And the content format of each work routine is also introduced in the format of each crontab work. Similarly, we need to use shell sc
How to use the Linux file remote copy command scp
Publish Date:2025/04/08 Views:151 Category:OPERATING SYSTEM
-
Scp copies files between two hosts over the network, and the data is encrypted during transmission. Its underlying layer uses ssh for data transmission. And it has the same authentication mechanism and the same security level as ssh. When u